<script lang="ts">
	import { courses } from '$lib';
	import Logo from '$lib/Logo.svelte';
	import type { MdFilterChip, MdOutlinedSelect } from '@material/web/all';
	import type { LayoutData } from './$types';
	import { onMount } from 'svelte';
	import { goto } from '$app/navigation';
	import expanded from '$lib/expanded';

	export let data: LayoutData;

	let outlinedSelect: MdOutlinedSelect;

	onMount(() => {
		outlinedSelect.addEventListener('change', () => {
			if (parseInt(outlinedSelect.value) != data.courseId) {
				goto(`/class/${outlinedSelect.value}`);
			}
		});
	});

	import { navigating } from '$app/stores';
	import SegmentedFilterChip from '$lib/segmented-filter-chip.svelte';
	import ThreadPreview from './ThreadPreview.svelte';
	import { scale } from 'svelte/transition';
	import type { Thread } from '$lib/types';
	import Darkmode from '$lib/darkmode.svelte';

	$: if ($navigating) $expanded = false;

	$: course = courses.find((c) => c.id == data.courseId);

	let isUnreadFilterChip: MdFilterChip;
	let isInstructor = false;

	let viewUnreadOnly = false,
		resolvedViews = [true, true],
		typeViews = [true, true];

	let filtersApplied: string[] = [];

	$: unreadFilter = (t: Thread) => t.unread || (t.unread == 0 && !viewUnreadOnly);
	$: resolvedFilter = (t: Thread) =>
		(t.resolved && resolvedViews[0]) || (!t.resolved && resolvedViews[1]);
	$: requiresAnswerFilter = (t: Thread) =>
		(t.requiresAnswer && typeViews[0]) || (!t.requiresAnswer && typeViews[1]);
	$: filtersFilter = (t: Thread) =>
		filtersApplied.length == 0 || t.tags.find((tag) => new Set(filtersApplied).has(tag));

	$: grandFilter = (t: Thread) =>
		unreadFilter(t) && resolvedFilter(t) && requiresAnswerFilter(t) && filtersFilter(t);

	onMount(() => {
		isUnreadFilterChip.addEventListener('click', () => {
			viewUnreadOnly = isUnreadFilterChip.selected;
		});
	});
</script>

<div style:height="100%" style:display="flex" style:flex-direction="column">
	<header>
		<div id="logo">
			<Logo></Logo>
		</div>
		<div id="navbutton">
			<md-icon-button
				style:--md-icon-button-icon-size="32px"
				toggle
				selected={$expanded}
				on:change={() => {
					$expanded = !$expanded;
				}}
			>
				<md-icon>menu</md-icon>
				<md-icon slot="selected">menu_open</md-icon>
			</md-icon-button>
		</div>
		<div id="select-course">
			<md-outlined-select style:width="100%" bind:this={outlinedSelect}>
				{#each courses as course}
					<md-select-option selected={course.id == data.courseId} value={course.id}>
						<div slot="headline">{course.title}</div>
					</md-select-option>
				{/each}
			</md-outlined-select>
		</div>
		<Darkmode></Darkmode>
	</header>

	{#if course}
		{@const unreadInstructor = course.threads
			.filter(grandFilter)
			.filter((t) => t.isInstructor && t.unread).length}
		{@const unreadStudent = course.threads
			.filter(grandFilter)
			.filter((t) => !t.isInstructor && t.unread).length}
		<div id="thread">
			<div id="threads" class={$expanded ? 'expanded' : 'unexpanded'}>
				<div id="aside-header">
					<md-outlined-text-field id="search" type="search" placeholder="Search" class="search">
						<md-icon slot="leading-icon">search</md-icon>
					</md-outlined-text-field>
					<md-filled-icon-button
						href="/class/{course.id}/create"
						style:--md-filled-icon-button-icon-size="32px"
						style:--md-filled-icon-button-container-width="56px"
						style:--md-filled-icon-button-container-height="56px"
					>
						<md-icon>edit</md-icon>
					</md-filled-icon-button>
				</div>
				<div id="filters">
					<md-chip-set>
						<md-filter-chip bind:this={isUnreadFilterChip} label="Unread" selected={viewUnreadOnly}
						></md-filter-chip>
						<SegmentedFilterChip>
							{#each resolvedViews as resolvedView, i}
								<!-- svelte-ignore a11y-no-static-element-interactions -->
								<!-- svelte-ignore a11y-click-events-have-key-events-->
								<md-filter-chip
									label={i ? 'Unresolved' : 'Resolved'}
									selected={resolvedView}
									on:click={() => {
										resolvedView = !resolvedView;
									}}
								></md-filter-chip>
							{/each}
						</SegmentedFilterChip>
						<SegmentedFilterChip>
							{#each typeViews as typeView, i}
								<!-- svelte-ignore a11y-no-static-element-interactions -->
								<!-- svelte-ignore a11y-click-events-have-key-events-->
								<md-filter-chip
									label={i ? 'Note' : 'Question'}
									selected={typeView}
									on:click={() => {
										typeView = !typeView;
									}}
								></md-filter-chip>
							{/each}
						</SegmentedFilterChip>

						{#each course.tags as tag}
							<!-- svelte-ignore a11y-no-static-element-interactions -->
							<!-- svelte-ignore a11y-click-events-have-key-events-->
							<md-filter-chip
								label={tag}
								style:text-transform="capitalize"
								on:click={() => {
									if (filtersApplied.find((t) => t === tag)) {
										filtersApplied = filtersApplied.filter((t) => t !== tag);
									} else {
										filtersApplied = [...filtersApplied, tag];
									}
								}}
							></md-filter-chip>
						{/each}
					</md-chip-set>
				</div>
				<aside>
					<md-tabs
						style:--md-primary-tab-container-color="transparent"
						on:change={() => {
							isInstructor = !isInstructor;
						}}
					>
						<md-primary-tab active={isInstructor}>
							<div
								slot="icon"
								class="emoji {unreadInstructor ? 'badged' : ''}"
								data-value={unreadInstructor}
							>
								🏫
							</div>
							Instructors
						</md-primary-tab>
						<md-primary-tab active={!isInstructor}>
							<div
								slot="icon"
								class="emoji {unreadStudent ? 'badged' : ''}"
								data-value={unreadStudent}
							>
								🎓
							</div>
							Students
						</md-primary-tab>
					</md-tabs>
					{#each course.threads
						.filter((t) => t.isInstructor == isInstructor)
						.filter(grandFilter) as thread (thread.id)}
						<div transition:scale>
							<ThreadPreview
								courseId={data.courseId}
								{thread}
								selected={thread.id === data.threadId}
							></ThreadPreview>
						</div>
					{/each}
				</aside>
			</div>

			<main>
				<slot />
			</main>
		</div>
	{/if}
</div>

<style>
	.badged {
		position: relative;
		width: fit-content;

		&::after {
			position: absolute;
			content: attr(data-value);
			background: var(--md-sys-color-error);
			color: var(--md-sys-color-on-error);
			border-radius: 100%;
			font-size: 16px;
			left: 100%;
			bottom: 100%;
			transform: translate(-50%, 75%);
		}
	}
	#search {
		background-color: var(--md-sys-color-surface);
		--md-outlined-text-field-container-shape: 2em;
		border-radius: 2em;
		--md-outlined-text-field-outline-width: 0;
	}

	md-outlined-select {
		background-color: var(--md-sys-color-surface);
		--md-outlined-select-text-field-container-shape: 2em;
		border-radius: 2em;
	}

	#logo {
		display: flex;
		align-items: center;
	}

	#navbutton {
		display: none;
	}

	:global(html) {
		height: 100dvh;
	}

	:global(body) {
		height: 100%;
	}

	#select-course {
		width: 60ch;
	}

	header {
		color: var(--md-sys-color-primary);
		display: flex;
		gap: 1em;
		align-items: center;
		justify-content: space-between;
		padding: 1em 2em;
	}

	@media (width <= 900px) {
		#navbutton {
			display: block;
		}

		#logo {
			display: none;
		}
	}

	#thread {
		flex: 1;
		display: flex;
		margin: 0 2em 2em;
		overflow: hidden;
		gap: 1em;
		position: relative;
	}

	#aside-header {
		display: flex;
		align-items: center;
		gap: 1em;
	}

	aside {
		height: 100%;

		& [slot='supporting-text'] {
			display: -webkit-box;
			-webkit-box-orient: vertical;
			-webkit-line-clamp: 2;
		}

		& [slot='headline'].unread {
			font-weight: 600;
		}
	}

	#threads {
		display: flex;
		flex-direction: column;
		flex: 1;
		gap: 1em;
		max-width: 40ch;
		width: -moz-available;
		width: -webkit-fill-available;
		width: fill-available;
		height: 100%;
		transition: transform 150ms ease-in;
		will-change: transform;
		background-color: var(--md-sys-color-surface-variant);
	}

	@media (width <= 900px) {
		#threads {
			position: absolute;
			width: 100%;
			max-width: none;
			z-index: 2;
			padding-right: 1em;
			border-inline-end: 1px solid var(--md-sys-color-outline);
		}

		#threads.unexpanded {
			transform: translateX(-150%);
		}
	}

	aside {
		overflow: auto;

		& md-list {
			height: 100%;
		}
	}

	main {
		border-radius: 1em;
		flex: 1;
		overflow: auto;
	}

	#filters {
		& md-chip-set {
			justify-content: center;
		}
	}

	#search {
		flex: 1;
	}
</style>
